#include <stdlib.h>
#include "upnpd.h"
#include "gateway.h"
#include "sample_util.h"
#define dprintf(...)
/*******************************************************************************
 *  IGDDeviceRequestConnection
 ******************************************************************************/
int IGDDeviceRequestConnection()
{
    char value[DS_MAX_VAL_LEN];
    int ret=0;

//we should turn on our WAN device here.
	system("rc wan restart");
	sprintf(value, "%s", "Connected");

    ret = IGDDeviceSetServiceTableVar(DS_SERVICE_WANIPConnection, DS_WANIPConn_ConnectionStatus, value);

    return(ret);
}

/*******************************************************************************
 *  IGDDeviceForceTermination
 ******************************************************************************/
int IGDDeviceForceTermination()
{
    char value[DS_MAX_VAL_LEN];
    int ret=0;

// we should shutdown our WAN device here.
	system("rc wan stop");

  sprintf(value, "%s", "Disconnected");
  ret = IGDDeviceSetServiceTableVar(DS_SERVICE_WANIPConnection, DS_WANIPConn_ConnectionStatus, value);
  return(ret);
}

static int PortMappingNumberofEntries=0;

/* adding port mapping entry to kernel */
int addPortForward(char *Proto, char *ExtIP, int ExtPort, 
	char *IntIP,int IntPort,char* RmtIP)
{
	char command[255];
	extern struct GateEnv gate;

	char value[10];
	int ret=0;

	dprintf("%s\n",gate.ext_ifname);

	if(strcmp(gate.ext_ifname,"none")!=0)
	{
		sprintf(command,"/usr/sbin/iptables -t nat -I PREROUTING -d %s -p %s --dport %d -j DNAT --to %s:%d", ExtIP,Proto,ExtPort, IntIP, IntPort);
		dprintf("%s\n",command);
		system(command);
		//sprintf(command,"/usr/sbin/iptables -I FORWARD -p %s -d %s --dport %d -j ACCEPT", Proto, ExtIP, ExtPort);
		if (RmtIP == NULL || *RmtIP=='\0')    // add empty string judgement  john
			sprintf(command,"/usr/sbin/iptables -I FORWARD -d %s -p %s --dport %d -j ACCEPT", IntIP, Proto, IntPort);
		else
			sprintf(command,"/usr/sbin/iptables -I FORWARD -d %s -p %s --dport %d -s %s -j ACCEPT", IntIP, Proto, IntPort, RmtIP);
		dprintf("%s\n",command);
		system(command);	

	PortMappingNumberofEntries++;
	sprintf(value,"%d",PortMappingNumberofEntries);
	ret=IGDDeviceSetServiceTableVar(DS_SERVICE_WANIPConnection,DS_WANIPConn_PortMappingNumberOfEntries,value);
	return ret;
	}

	return (1);
}

/* deleting port mapping entry to kernel */
int delPortForward(char *Proto, char *ExtIP, int ExtPort, 
		char* IntIP, int IntPort,char *RmtIP)
{
	char command[255];
	extern struct GateEnv gate;

	char value[10];
	int ret=0;
	

//	printf("%s\n",gate.ext_ifname);

	if(strcmp(gate.ext_ifname,"none")!=0)
	{
		//sprintf(command, "/usr/sbin/iptables -t nat -D PREROUTING -p %s -d %s --dport %d -j DNAT --to %s:%d", Proto, ExtIP, ExtPort, IntIP, IntPort);
		sprintf(command,"/usr/sbin/iptables -t nat -D PREROUTING -d %s -p %s --dport %d -j DNAT --to %s:%d", ExtIP,Proto,ExtPort, IntIP, IntPort);
	dprintf("%s\n",command);
		system(command);
		if (RmtIP == NULL || *RmtIP=='\0')
			sprintf(command,"/usr/sbin/iptables -D FORWARD -d %s -p %s --dport %d -j ACCEPT", IntIP, Proto, IntPort);
		else
			sprintf(command,"/usr/sbin/iptables -D FORWARD -d %s -p %s --dport %d -s %s -j ACCEPT", IntIP, Proto, IntPort, RmtIP);
		//sprintf(command, "iptables -D FORWARD -p %s -d %s --dport %d -j ACCEPT", Proto, ExtIP, ExtPort);
		
	dprintf("%s\n",command);
		system(command);

	PortMappingNumberofEntries--;
	if (PortMappingNumberofEntries<0)
		PortMappingNumberofEntries=0;
		
	sprintf(value,"%d",PortMappingNumberofEntries);
	ret=IGDDeviceSetServiceTableVar(DS_SERVICE_WANIPConnection,DS_WANIPConn_PortMappingNumberOfEntries,value);
	return ret;

	}

	return (1);
}

#if 1
/** int strcmp_s(s1,s2,n) as strcmp, but compares at most n characters */
int strcmp_s(char *s1,char *s2)
{
    if((strlen(s2) > strlen(s1)) || (!s1 || !s2))
        return(0);
    for (;*s2 ;s1++,s2++)
        if (*s1 != *s2) return(-1);
    if(',' == *s2)
        return(0);
    else
        return(1);
}
#endif

/*******************************************************************************
 * LANHostConfigManagement DeleteDNSServer action
 ******************************************************************************/
int DeleteDNSServer(char *input_string)
{
    char *old_string;
    int slen1=strlen(input_string);
    int i,slen2;

    old_string=ds_service_table[DS_SERVICE_LANHostConfigManagement].VariableStrVal[DS_LANHostCM_DNSServers];
    slen2=strlen(old_string)-slen1;
    if(0 > slen2)
        return 0;
    slen1++;
    for(;*old_string;old_string++)
    {
        if(0 < strcmp_s(old_string,input_string))
        {
            for(i=0;i<slen2;i++)
                *(old_string+i)=*(old_string+i+slen1);
            *(old_string+slen2)=0;
            return 1;
        }
    }
    return 0;
}


/*******************************************************************************
 * LANHostConfigManagement DeleteIPRouter action
 ******************************************************************************/
int DeleteIPRouter(char *input_string)
{
    char *old_string;
    int slen1=strlen(input_string);
    int i,slen2;

    old_string=ds_service_table[DS_SERVICE_LANHostConfigManagement].VariableStrVal[DS_LANHostCM_IPRouters];
    slen2=strlen(old_string)-slen1;
    if(0 > slen2)
        return 0;
    slen1++;
    for(;*old_string;old_string++)
    {
        if(0 < strcmp_s(old_string,input_string))
        {
            for(i=0;i<slen2;i++)
                *(old_string+i)=*(old_string+i+slen1);
            *(old_string+slen2)=0;
            return 1;
        }
    }
    return 0;
}


/*******************************************************************************
 * LANHostConfigManagement DeleteReservedAddress action
 ******************************************************************************/
int DeleteReservedAddress(char *input_string)
{
    char *old_string;
    int slen1=strlen(input_string);
    int i,slen2;

    old_string=ds_service_table[DS_SERVICE_LANHostConfigManagement].VariableStrVal[DS_LANHostCM_ReservedAddr];
    slen2=strlen(old_string)-slen1;
    if(0 > slen2)
        return 0;
    slen1++;
    for(;*old_string;old_string++)
    {
        if(0 < strcmp_s(old_string,input_string))
        {
            for(i=0;i<slen2;i++)
                *(old_string+i)=*(old_string+i+slen1);
            *(old_string+slen2)=0;
            return 1;
        }
    }
    return 0;
}


int SetConnState(char *stateStr)
{
	IGDDeviceSetServiceTableVar(DS_SERVICE_WANIPConnection,DS_WANIPConn_ConnectionStatus,stateStr);	
        return 0;
}

int SetExtIPAddr(char *addr)
{
	IGDDeviceSetServiceTableVar(DS_SERVICE_WANIPConnection,DS_WANIPConn_ExternalIPAddress,addr);
	return 0;
}

int Set_ConnState_ExtIP(char *state,char *extip)
{
	static struct VarRec varrec[2];
	varrec[0].variable=DS_WANIPConn_ConnectionStatus;
	varrec[0].value=state;
	varrec[1].variable=DS_WANIPConn_ExternalIPAddress;
	varrec[1].value=extip;
	
	IGDDeviceSetServiceTableVars(2,DS_SERVICE_WANIPConnection,varrec);
	return 0;
}

