/* 2004.05.21  fix memory leak */
#include <stdio.h>
#include <signal.h>
#include <stdlib.h>
#include <unistd.h>
#include <time.h>
#include <string.h>
#include <sys/sysinfo.h>
#include "upnpd.h"
#include "tool.h"
#include "action.h"
/* Ron */
#include "dll.h"
extern int IGDDeviceStateTableInit(char*,char*);
extern int IGDdelAllPortForwarding(void);
extern int substr(char *infile, char *outfile, char *str_from, char *str_to);

struct GateEnv gate;

int custom_ttl;
int advertisement_expire=5;

extern int IGDDeviceCallbackEventHandler(Upnp_EventType, void*, void*);
extern unsigned int getIPAddress2(char *ifname);

/**
 *    if state changed ,return 1,else return 0
 */
int testConnState()
{
	static char connect_str[]="Connected";
	static char disconnect_str[]="Disconnected";
	static int state_sav=-2;
	int state;
	char *value;
	state=getConnectionStatus();
//	printf("connect_state=%d, old_state=%d \n",state,state_sav);
	if (state!=state_sav) {
			state_sav=state;
			if (state==1) 
				value=connect_str;
			else
				value=disconnect_str;
			strcpy(gate.ConnectionStatus,value);
		//	SetConnState(value);
			getLayer1MaxBitRate();
			return 1;
	}	
	return 0;
}


int testExtIPAddr()
{
	char *addr_s;
	static unsigned int exaddr=0;
	unsigned int taddr=getIPAddress2(gate.ext_ifname);

	if (exaddr!=taddr) {
		exaddr=taddr;
	/*	addr_s=getIPAddress(gate.ext_ifname)?:"0.0.0.0";
		strcpy(gate.ExternalIPAddress,addr_s);
		setExIPAddr(gate.ExternalIPAddress);*/
		addr_s=getIPAddress(gate.ext_ifname);
		if (addr_s!=NULL) 
		{
			strcpy(gate.ExternalIPAddress,addr_s);
//			setExIPAddr(gate.ExternalIPAddress);
		}
		else   // not send notify if ipaddress == 0.0.0.0
		{
			strcpy(gate.ExternalIPAddress,"");
		}
		return 1;
	}
	return 0;
}


void *handleExpire()
{
    time_t t;
    DLL tmp;
	int i,len;
	int ConnStateChg,ExtIPChg;

	
    while(1)
    {

	    ConnStateChg=testConnState();
	    ExtIPChg=testExtIPAddr();
	    if ( ConnStateChg && ExtIPChg)
	    {
		    Set_ConnState_ExtIP(gate.ConnectionStatus,gate.ExternalIPAddress);
	    }
	    else if (ConnStateChg)
		    SetConnState(gate.ConnectionStatus);
	    else if (ExtIPChg)
		    SetExtIPAddr(gate.ExternalIPAddress);
	    

	    len=LinkLength();
        time(&t);
	    for(i=len-1;i>=0;i--)
	    {
            tmp=Search(i);
            if((tmp->data.lease_t!=0)&&(t>=tmp->data.lease_t))
            {
                delPortForward(tmp->data.Protocol,
                    getIPAddress(gate.ext_ifname)?:"0.0.0.0",
        	        tmp->data.ExternalPort,
           		    tmp->data.InternalClient,
           		    tmp->data.InternalPort,
           		    tmp->data.RemoteHost);	
	    		Delete(tmp);
	    	}
	    }
	    sleep(2);
	}
}


extern int make_upnp_xml(char *ipaddr,int port);

int main(int argc, char** argv)
{

    int ret=1;
    int port=0;
    char *desc_doc_name=NULL, *web_dir_path=NULL;
    int sig;
    char fullurl[200];
    char desc_doc_url[200];
    struct sysinfo info;
    sigset_t sigs_to_catch;
    pthread_t pid;
    
    bzero(&gate,sizeof(struct GateEnv));
    
    if (argc != 5){
		printf("Usage: upnpd <ext ifname> <int ifname> <adv time> <ttl>\n");
		printf("Example: upnpd ppp0 eth0 30 4\n");
		printf("Example: upnpd eth1 eth0 10 1\n");
		exit(0);
    }


	/* Variable initialize */

    gate.int_ifname=argv[2];
    gate.ext_ifname=argv[1];  

    strcpy(gate.InternalIPAddress,getIPAddress(gate.int_ifname));
//    strcpy(gate.ExternalIPAddress,getIPAddress(gate.ext_ifname)?:"0.0.0.0");
//    printf("ExternalIPAddress=%s\n",gate.ExternalIPAddress);
    getConnectionStatus();
   getLayer1MaxBitRate();    
 
    sysinfo(&info);
    gate.startup_time = info.uptime;
//  gate.startup_time = time(NULL);       
    custom_ttl=atoi(argv[4]);
 
    gate.advr_expire=(atoi(argv[3]))*120;//argv[3]*60*2 raul fix , UPNP interval time is the half value of setting 
//		printf("raul debug set interval time == %d s\n",gate.advr_expire);
//    gate.advr_expire=(atoi(argv[3]))*2; /* by cody, change to seconds unit */
    
    desc_doc_name=DEF_DOCUMENT;  
    web_dir_path=DEF_DIR_PATH;  

// remove sleep to rcS
//    sleep(20);


//    port=DEF_PORT;
    if ((ret = UpnpInit(gate.InternalIPAddress, port)) != UPNP_E_SUCCESS) {
	printf("Error with UpnpInit -- %d\n", ret);
	UpnpFinish();
	exit(1);
    }
    printf("UPnP Initialized\n");
   
    if (port==0)
        port = UpnpGetServerPort();


    if (make_upnp_xml(gate.InternalIPAddress,port)<0) {
		printf("Error with formatting upnp description xml  \n");
		exit(1);
    	}



     sprintf(fullurl, "http://%s:%d/%s", gate.InternalIPAddress , port, desc_doc_name);
     sprintf(desc_doc_url, "http://%s:%d", gate.InternalIPAddress , port);
    
    printf("Intialized UPnP \n\twith fullurl=%s\n\t", fullurl);
    printf("\t     ipaddress=%s port=%d\n", gate.InternalIPAddress, port);
    printf("\t     web_dir_path=%s\n", web_dir_path);
    printf("\t     desc_doc_url=%s\n", desc_doc_url);

	printf("Specifying the webserver root directory -- %s\n", web_dir_path);
    if ((ret = UpnpSetWebServerRootDir(web_dir_path)) != UPNP_E_SUCCESS) {
	printf("Error specifying webserver root directory -- %s: %d\n", web_dir_path, ret);
	UpnpFinish();
	exit(1);
    }


    printf("Registering the RootDevice\n");
    if ((ret = UpnpRegisterRootDevice(fullurl, IGDDeviceCallbackEventHandler, &gate.device_handle, &gate.device_handle)) != UPNP_E_SUCCESS) {
	printf("Error registering the rootdevice : %d\n", ret);
	UpnpFinish();
	exit(1);
    } else {
	printf("RootDevice Registered\n");
     
	printf("Initializing State Table\n");
	IGDDeviceStateTableInit(desc_doc_url,desc_doc_name);
	testConnState();   // set connectStatus
	
	
	if ((ret = UpnpSendAdvertisement(gate.device_handle, gate.advr_expire)) != UPNP_E_SUCCESS) {
	    printf("Error sending advertisements : %d\n", ret);
	    UpnpFinish();
	    exit(1);
	}
	printf("Advertisements Sent\n");
    }
    //pthread_t pid;
    pthread_create(&pid, NULL, handleExpire, NULL);

    /* Catch Ctrl-C and properly shutdown */
   
    sigemptyset(&sigs_to_catch);
    sigaddset(&sigs_to_catch, SIGINT);
    sigaddset(&sigs_to_catch, SIGTERM);
    sigwait(&sigs_to_catch, &sig);
    printf("upnpd shutting down on signal %d...\n", sig);
    UpnpUnRegisterRootDevice(gate.device_handle);
    UpnpFinish();

    IGDdelAllPortForwarding();
    /* remove the upnptab file if exist */
//    if(access("/tmp/upnptab",F_OK)==0)
//    	remove("/tmp/upnptab");
    exit(0);
}


