#ifndef RA2882ETHEND_H
#define RA2882ETHEND_H

#ifdef DSP_VIA_NONCACHEABLE
#define ESRAM_BASE	0xa0800000	/* 0x0080-0000  ~ 0x00807FFF */
#else
#define ESRAM_BASE	0x80800000	/* 0x0080-0000  ~ 0x00807FFF */
#endif

#define RX_RING_BASE	((int)(ESRAM_BASE + 0x7000))
#define TX_RING_BASE	((int)(ESRAM_BASE + 0x7800))

#if defined(CONFIG_RALINK_RT2880)
#define NUM_TX_RINGS 	1
#else
#define NUM_TX_RINGS 	4
#endif

#ifdef CONFIG_RAETH_ROUTER
#define NUM_RX_DESC     256
#define NUM_TX_DESC    	256
#else
#define NUM_RX_DESC     256
#define NUM_TX_DESC     256
#endif
#define NUM_RX_MAX_PROCESS 64

#define DEV_NAME        "eth2"
#define RA2882_ENET0	RA2882ETH_BASE

#define RT_EEPROM_BASE  (CONFIG_FLASH_PHYSMAP_START + 0x40000)
#define GMAC2_ADDR      (RT_EEPROM_BASE + 0x22)
#define GMAC0_ADDR      (RT_EEPROM_BASE + 0x28) 
#define GMAC1_ADDR      (RT_EEPROM_BASE + 0x2E)

#define RT2880_IRQ_ENET0	3 	/* hardware interrupt #3, defined in RT2880 Soc Design Spec Rev 0.03, pp43 */

#define RT2880_FE_INT_STATUS_REG (*(volatile unsigned long *)(FE_INT_STATUS))
#define RT2880_FE_INT_STATUS_CLEAN(reg) (*(volatile unsigned long *)(FE_INT_STATUS)) = reg

//#define RAETH_DEBUG
#ifdef RAETH_DEBUG
#define RAETH_PRINT(fmt, args...) printk(KERN_INFO fmt, ## args)
#else
#define RAETH_PRINT(fmt, args...) { }
#endif

struct net_device_stats *ra_get_stats(struct net_device *dev);

void ei_tx_timeout(struct net_device *dev);
int rather_probe(struct net_device *dev);
int ei_open(struct net_device *dev);
int ei_close(struct net_device *dev);

int ra2882eth_init(void);
void ra2882eth_cleanup_module(void);
void phyInit(void);

void ei_xmit_housekeeping(unsigned long data);
void START_RT2880_ETH(void);

int inline rt3052_esw_soft_padding(struct sk_buff  **skb);
int ppe_ebl(int ebl);

#endif
