#-----------------------------------------------------------
#           Host CPU Arch Detect
#-----------------------------------------------------------

TOP:=/mnt/home/tom_lee/GPL_WBR-6010/WBR-6010/src
CONFIG_CROSS_COMPILER_PATH=$(TOP)/../buildroot-gdb/bin

ENDIAN        ?= little
ARCH          = mips
CROSS_COMPILE = $(CONFIG_CROSS_COMPILER_PATH)/mipsel-linux-uclibc-
KERNEL_CROSS_COMPILE = $(CROSS_COMPILE)

CC        = $(CROSS_COMPILE)gcc $(CPUFLAGS)
AS        = $(CROSS_COMPILE)as $(CPUFLAGS)
CXX       = $(CROSS_COMPILE)g++ $(CPUFLAGS)
AR        = $(CROSS_COMPILE)ar
LD        = $(CROSS_COMPILE)ld
OBJCOPY   = $(CROSS_COMPILE)objcopy
RANLIB    = $(CROSS_COMPILE)ranlib
STRIPTOOL = $(CROSS_COMPILE)strip
STRIP     = $(STRIPTOOL)

HOSTCC   = cc
SUBARCH= "mipsel-linux-uclibc-"

export CONFIG_CROSS_COMPILER_PATH CROSS_COMPILE CC AS CXX AR LD OBJCOPY  RANLIB STRIP

#--------------------------------------------------------------
#               Lib Dirctory
#--------------------------------------------------------------
GCC_DIR   = $(shell $(CC) -v 2>&1|grep specs|sed -e 's/.* \(.*\)specs/\1\./')
MACH_DIR  = $(shell $(CC) -print-multi-directory)

UCLINUX_BUILD_SET = 0					# have we set a special config below

ifndef NON_SMP_BUILD
HOST_NCPU := $(shell if [ -f /proc/cpuinfo ]; then n=`grep -c processor /proc/cpuinfo`; if [ $$n -gt 1 ];then expr $$n \* 2; else echo $$n; fi; else echo 1; fi)
else
HOST_NCPU := 1
endif

export HOST_NCPU

#-------------------------------------------------------------
#   Module Name
#-------------------------------------------------------------
MODULE_NAME=WBR-6010

#--------------------------------------------------------------
#           Version
#--------------------------------------------------------------
SDK_VERSION = 2.1.0
AP_VERSION = 1.5.0
KERNEL_VERSION = 2.4.30

#--------------------------------------------------------------
#           Fuction Cotrol
#--------------------------------------------------------------
#INSTALL_ROOT := $(TOP)/rootfs
#export INSTALLDIR := $(INSTALL_ROOT)
#export TARGETDIR := $(INSTALL_ROOT)
